--[[
	DStyle
		A skinner, of sorts
--]]

DStyle = CreateFrame('Frame')
DStyle:SetScript('OnEvent', function(self, event, addon)
	if event == 'ADDON_LOADED' and addon == 'DoggyStyle' then
		self:SetStyle('Squared')
		self:UnregisterEvent('ADDON_LOADED')
	end
end)
DStyle:RegisterEvent('ADDON_LOADED')

local Action = Bongos3:GetModule('ActionBar')
local ActionButton = Action.Button
local TEXTURE_PATH = 'Interface\\AddOns\\DoggyStyle\\textures\\'

function DStyle:RegisterStyle(name, action)
	self.styles = self.styles or {}
	self.styles[name] = action
end

function DStyle:SetStyle(name)
	local style = self:GetStyle(name)
	if style then
		style(self)
		self:Update()
	end
end

function DStyle:GetStyle(name)
	return self.styles and self.styles[name]
end

function DStyle:Update()
	ActionButton:ForAll('Skin')
end


DStyle:RegisterStyle('Squared', function(self)
	function ActionButton:Skin()
		local icon = self.icon
		icon:ClearAllPoints()
		icon:SetPoint('CENTER')
		icon:SetWidth(32); icon:SetHeight(32)

		local border = self.border
		border:SetWidth(44); border:SetHeight(44)
		border:SetTexture(TEXTURE_PATH .. 'Square')

		local cd = self.cooldown
		cd:SetWidth(36); cd:SetHeight(36)
		cd:SetScale(0.9)

		local flash = self.flash
		flash:SetWidth(30); flash:SetHeight(30)

		local hotkey = self.hotkey
		hotkey:SetPoint('TOPLEFT', -1, 8)
		hotkey:SetDrawLayer('OVERLAY')

		local count = self.count
		count:SetPoint('BOTTOMRIGHT', -3, 3)
		count:SetDrawLayer('OVERLAY')

		local nt = self:GetNormalTexture()
		nt:SetWidth(37); nt:SetHeight(37)
		nt:SetTexture(TEXTURE_PATH .. 'Square')
		nt:SetDrawLayer('OVERLAY')
		nt:SetVertexColor(0.5, 0.5, 0.5)

		local ht = self:GetHighlightTexture()
		ht:SetWidth(37); ht:SetHeight(37)
		ht:SetTexture(TEXTURE_PATH .. 'SquareHighlight')
		ht:SetBlendMode('ADD')
		ht:SetVertexColor(0, 0, 1)

		local pt = self:GetPushedTexture()
		pt:SetWidth(38); pt:SetHeight(37)
		pt:SetTexture(TEXTURE_PATH .. 'SquareHighlight')
		pt:SetBlendMode('ADD')
		pt:SetVertexColor(1, 1, 0)

		local ct = self:GetCheckedTexture()
		ct:SetWidth(32); ct:SetHeight(32)
		ct:SetTexture(TEXTURE_PATH .. 'Square')
		ct:SetBlendMode('ADD')
	end

	function ActionButton:UpdateNormalTexture()
		--noop
	end
end)